
-- afficher la table geo
Select * -- toutes les colonnes (toutes les lignes)
From DimGeography

-- afficher la table geo mais seulement les 50 premires lignes
Select top 50 * 
From DimGeography

-- afficher les pays
-- affiche une colonne : colonne entire telle qu'elle est BDD
-- affiche la colonne sans doublon : distinct
Select distinct FrenchCountryRegionName 
From DimGeography

-- affiche pays et ville
Select distinct FrenchCountryRegionName ,city
From DimGeography

-- renommer les colonnes :) cotes et/ou "
-- les cotes pas obligatoires car il n'y a qu'un mot
-- as n'est pas obligatoire
select city as ville,	--'ville' cotes pas necessaire
	   FrenchCountryRegionName as 'pays du client',
	   IpAddressLocator as 'l''email' -- double cote / guillemets deb/fin
From dimgeography

-- exemple avec fonction intgre (FI) sur une colonne FI(col) : rose
-- Fonctions de calcul (agrgation : FA : sum, avg, min, count)
-- Fonctions de texte (maj, supr espaces, concatner, gauche)
-- Fonction de DATE (anne - YEAR//extract from year, mois, jour, min, datediff)
-- Fonction de conversions
select BirthDate, 
	   year(BirthDate) as 'anne de naissance'
-- piocher l'anne dans une date (naissance)
From DimCustomer

-- Afficher le pays et le code postal
-- et trier par pays ascendant puis code postal desc
select FrenchCountryRegionName as pays,
		PostalCode as 'code postal'
From DimGeography
-- order by FrenchCountryRegionName asc, PostalCode desc
-- order by FrenchCountryRegionName, PostalCode desc
order by pays, [code postal] desc
-- on ne renomme pas les colonnes
-- trier le rsultat de requtes : mes colonnes maintenant s'appellent pays

----------------------------- WHERE -----------------------
-- 1. SELECT -- afficher/voir, renommer, distinct, top (virgule)
--- 2. FROM  -- la/les table(s) utilise(s)
---- 3. WHERE -- conditions/Filtres BDD
----- 4.
------ 5. 
------- 6. ORDER BY -- trier (virgule) -- Utiliser le renommage colonne

-- critres simples = <>
-- UNE SEULE VALEUR dans la mme colonne strictement gal/diffrent/suprieur
-- clients franais excepts les parisiens
Select *
From DimGeography
where FrenchCountryRegionName = 'France'
-- quand dans la colonne PAYS la valeur est gale  FRANCE
	AND city <> 'Paris'

-- IN // NOT IN : dans (in), pas dans (not in) la liste suivante(,,)
-- PLUSIEURS VALEURS dans la mme colonne strictement gal/diffrent/suprieur
-- clients franais/Etats UNIS excepts les parisiens (defense) et miami
Select *
From DimGeography
where CountryRegionCode IN ('FR', 'US')
-- soit dans la liste suivante (fr US)
-- quand dans la colonne PAYS la valeur est gale  FRANCE ou  US
	AND city NOT IN ('Paris', 'paris la defense','Miami')

-- LIKE // NOT LIKE : contient/ne contient pas %
-- Je veux les pays dont le nom commence par A (contient A au dbut)
-- ET dont le stateprovince ne contient pas South
Select distinct FrenchCountryRegionName, StateProvincename
From DimGeography
where FrenchCountryRegionName like 'a%'
-- au dbut a puis qu'importe (%)
and StateProvinceName not like '%south%'

-- Tous les pays dont le nom commence par A ou C
Select distinct FrenchCountryRegionName,
	left(FrenchCountryRegionName, 1) as '1ere lettre pays' --  gauche
From DimGeography
where left(FrenchCountryRegionName, 1) in ('A','c')
-- quand la premire lettre du pays est dans la liste suivante A OU C
--FrenchCountryRegionName like 'a%'
--OR FrenchCountryRegionName like 'c%'

-- Entre telle et telle valeur : between and (numrique, dates, lettres)
-- geokey entre 170 et 176
Select *
From DimGeography
WHERE GeographyKey between 170 and 176

-- GESTION DES NULL - IS NULL/ IS NOT NULL
-- quand le middlename est non renseigne (pas de valeurs : null/vide)
-- et quand le enddate est renseigne (l'employ est parti : not null/pas vide)
select *
From DimEmployee
where MiddleName is null
	and EndDate is not null

	--- exo 13
select *
From DImcustomer
where FrenchEducation ='baccalaurat' and CommuteDistance = '5-10 miles'
 UNION
select *
From dimcustomer
where FrenchEducation ='bac + 4' and CommuteDistance = '1-2 miles'

----------------------------- GROUP BY -----------------------
-- 1. SELECT -- afficher/voir, renommer, distinct, top (virgule)
--- 2. FROM  -- la/les table(s) utilise(s)
---- 3. WHERE -- conditions/Filtres BDD (and/or)
----- 4. GROUP BY -- Regrouper PAR (agrgation sum count + group by copier coller select)
------ 5. 
------- 6. ORDER BY -- trier (virgule) -- Utiliser le renommage colonne

-- 1: compter le nombre de villes par pays
select FrenchCountryRegionName, count(City) as 'nombre de villes'
From DimGeography
Group by FrenchCountryRegionName -- regroupe par pays

-- calcul
-- PAR : crire le group by
-- copie-colle le contenu du group by dans le select

-- 2 : Nombre d'employs par dpartement et par type de poste (title)
-- trier par dep asc et pas nombre d'employs desc
select DepartmentName , title, 
		count(EmployeeKey) as 'nombre d''employs'
From DimEmployee
group by DepartmentName , title
order by DepartmentName, [nombre d'employs] desc

----------------------------- GROUP BY -----------------------
-- 1. SELECT -- afficher/voir, renommer, distinct, top (virgule)
--- 2. FROM  -- la/les table(s) utilise(s)
---- 3. WHERE -- conditions/Filtres BDD (and/or)
----- 4. GROUP BY -- Regrouper PAR (agrgation + group by copier coller select)
------ 5. HAVING -- conditions/filtres Fagrgation (sum count avg min max)
------- 6. ORDER BY -- trier (virgule) -- Utiliser le renommage colonne

-- Nombre de produits par couleur
-- le numro de produit est entre 2 et 1216 pas une FA
-- que le nombre de produit est suprieur  50 -count FA
Select Color, count(ProductKey) as 'nombre de produits'
From DimProduct
where productkey between 2 and 1216
group by Color
having count(ProductKey) > 50

-- condition : est-elle sur une fonction d'agrgation ?

-- 1: compter le nombre de villes par pays
-- quand le nombre de villes est suprieur  60 -- FA (count)
-- quand le geographykey est entre 50 et 500
select FrenchCountryRegionName, count(City) as 'nombre de villes'
From DimGeography
where GeographyKey between 50 and 500
Group by FrenchCountryRegionName -- regroupe par pays
having count(City) > 60

-- 2 : Nombre d'employs par dpartement et par type de poste (title)
-- trier par dep asc et pas nombre d'employs desc
-- quand l'employ est n  partir de 1980
-- quand le dpartement/type a plus de 10 employs -- FA having
select DepartmentName , title, 
		count(EmployeeKey) as 'nombre d''employs'
From DimEmployee
WHERE year(BirthDate) >= 1980
group by DepartmentName , title
having count(EmployeeKey) > 10
order by DepartmentName, [nombre d'employs] desc

---------------------------- Fonctions intgres en +
-- Diffrents type de count
-- le nombre de lignes - count(*)
-- le nombre de produits -- count(colkey) : le nombre de val renseignes
-- le nombre de produits avec une fin de date de prod
-- le nombre de couleurs
select count(*) as 'nombre de lignes',
		count(ProductKey) as 'nombre de produits',
		count(EndDate) as 'nb prod fin',
		count(distinct color) as 'nombre de couleurs' -- compter sans doublons/distinctement
From dimproduct

-- L'ge des employs + l'anciennet en annes
Select FirstName, lastname, BirthDate,
		DATEDIFF(year, BirthDate, getdate() ) as ge,
		datediff(year, hiredate, getdate()) as anciennet
-- datediff ( unit de mesure, date dbut, date fin)
-- ge : date de naissance, date du jour GETDATE(), SYSDATE
From DimEmployee

-- unitsbalance moyen, unitcost max
-- par an, trimestre et par mois
-- trier par ordre asc anne et mois
-- quand le mois est entre 3 et 12
-- quand le unitcost max est suprieur ou gal  1000
Select year(MovementDate) as anne, 
		datepart(quarter, movementdate) as trimestre, 
		month(movementdate) as mois,
		avg(UnitsBalance) as 'ub moyen',
		max(unitcost) as 'unitcost max'
From FactProductInventory
where month(MovementDate) between 3 and 12
Group by year(MovementDate), datepart(quarter, movementdate), month(movementdate)
having max(unitcost) >= 1000
order by anne, mois

---------------------------------- JOINTURES INTERNES ----------------------
-- Cls : table1.cp =table2.cs -- mme nom de colonne dans plusieurs tables
-- Rcuprer colonnes et/OU faire la correspondance (filtrer lignes)
-- Relation vers plusieurs/infini : doublons (distinct)
-- Appelle les 2 premires tables + Type
-- Comment on relie les tables
-- Appelle la 3me table + Type 
-- Comment on relie cette 3me table

--1 er type de jointure : inner join / Join : correspondance parfaite

-- afficher les revendeurs avec au moins une vente
-- quelles sont les tables dont j'ai besoin ? dimreseller & factresellersales
-- quelle est la colonne de correspondance ? resellerkey
Select distinct ResellerName, DimReseller.ResellerKey
From DimReseller JOIN factresellersales -- appel des 2 premires tables
-- From factresellersales join DimReseller
	ON DimReseller.ResellerKey = FactResellerSales.ResellerKey
	--ON FactResellerSales.ResellerKey= DimReseller.ResellerKey

-- en plus : je veux afficher le pays du revendeur
-- quelles sont les tables dont j'ai besoin ? dimreseller --> dimgeo
-- quelle est la colonne de correspondance ? geographykey
Select distinct ResellerName, DimReseller.ResellerKey, FrenchCountryRegionName
From DimReseller JOIN factresellersales -- appel des 2 premires tables
-- From factresellersales join DimReseller
	ON DimReseller.ResellerKey = FactResellerSales.ResellerKey
				 JOIN DimGeography -- appel 3me table
	ON DimGeography.GeographyKey = DimReseller.GeographyKey
	--comment elle est relie au reste !

---------------------------------- JOINTURES EXTERNES ----------------------
-- tous les revendeurs
-- numro de commande
Select distinct ResellerName, DimReseller.ResellerKey, SalesOrderNumber
From DimReseller LEFT JOIN factresellersales --gauche 
-- From factresellersales right JOIN DimReseller -- right
	ON DimReseller.ResellerKey = FactResellerSales.ResellerKey

-- 1: o sont tous mes revendeurs ? dimreseller
-- 2: mes revendeurs sont-il  droite ou  gauche du JOIN dans le code ?

-- les revendeurs qui n'ont jamais command
Select distinct ResellerName, DimReseller.ResellerKey --, FactResellerSales.*
From DimReseller LEFT JOIN factresellersales --gauche 
-- From factresellersales right JOIN DimReseller -- right
	ON DimReseller.ResellerKey = FactResellerSales.ResellerKey
where FactResellerSales.SalesOrderNumber is null
-- sur l'autre table : is null sur cl
-- pas de correspondance car sinon valeur cl obligatoire

------------------------ SOUS REQUTES -----------
------------------------ sous requtes dans le select
-- Afficher la moyenne des ventes en ligne
select round(avg(SalesAmount),2) From FactInternetSales

-- Afficher la moyenne des ventes par client
select dimcustomer.CustomerKey, LastName, 
		round(avg(SalesAmount),2) as 'moyenne par client'
From FactInternetSales Join dimcustomer
	on FactInternetSales.CustomerKey= dimcustomer.CustomerKey
group by dimcustomer.CustomerKey, LastName

-- les deux requtes ensembles et imbriques
-- Afficher la moyenne des ventes par client et la moyenne globale
select dimcustomer.CustomerKey, LastName, 
		round(avg(SalesAmount),2) as 'moyenne par client',
		(select round(avg(SalesAmount),2) From FactInternetSales) as moy_gnr
From FactInternetSales Join dimcustomer
	on FactInternetSales.CustomerKey= dimcustomer.CustomerKey
group by dimcustomer.CustomerKey, LastName

-- sous requte conditionnelle (where /having)
-- afficher seulement les clients quand leur moyenne est suprieur  moy_gnr
select dimcustomer.CustomerKey, LastName, 
		round(avg(SalesAmount),2) as 'moyenne par client',
		(select round(avg(SalesAmount),2) From FactInternetSales) as moy_gnr
From FactInternetSales Join dimcustomer
	on FactInternetSales.CustomerKey= dimcustomer.CustomerKey
group by dimcustomer.CustomerKey, LastName
having round(avg(SalesAmount),2) > 
		(select round(avg(SalesAmount),2) From FactInternetSales)
-- quand la moyenne par client est suprieur  la moyenne gnrale

------------------------------- SOUS requtes FROM -------
-- En moyenne, le nombre de produits par couleurs

-- en second : moyenne : requte principale
select avg([nombre de produits]) as 'moyenne'
FROM	-- en 1er : count(produits) : sous-requte
			(select color, count(productkey) as 'nombre de produits'
			From dimproduct
			group by color) as toto